/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public virtual Result Execute(ExternalCommandData commandData , ref string message, ElementSet elements) { //Get the document from external command data. UIDocument activeDoc = commandData.Application.ActiveUIDocument; Autodesk.Revit.DB.Document doc = activeDoc.Document; if (null == doc) { return(Result.Failed); } try { // Start detailed steel modeling transaction using (FabricationTransaction trans = new FabricationTransaction(doc, false, "Create hole in plate")) { // Creating a plate, using AdvanceSteel classes and objects // for more details, please consult http://www.autodesk.com/adv-steel-api-walkthroughs-2019-enu Reference eRef = activeDoc.Selection.PickObject(ObjectType.Element, "Pick a plate"); FilerObject filerObj = Utilities.Functions.GetFilerObject(doc, eRef); if (null == filerObj) { return(Result.Failed); } if (!(filerObj is Plate)) { return(Result.Failed); } // Point of reference for the hole in plate feature. We use GlobalPoint. GlobalPoint is the point where the plate is being hit when selected. Point3d p1 = new Point3d(eRef.GlobalPoint.X, eRef.GlobalPoint.Y, eRef.GlobalPoint.Z); Plate plate = filerObj as Plate; // Adding a hole to the plate, using AdvanceSteel classes and objects Matrix3d csHole = new Matrix3d(); csHole.SetCoordSystem(p1 * Utilities.Functions.FEET_TO_MM, Vector3d.kXAxis, Vector3d.kYAxis, Vector3d.kZAxis); ConnectionHolePlate hole = new ConnectionHolePlate(plate, csHole); hole.Arranger = new BoundedRectArranger(0, 0); hole.Arranger.Nx = 1; hole.Arranger.Ny = 1; hole.Hole = new Hole(100); plate.AddFeature(hole); hole.updateYourself(); trans.Commit(); } } catch (Autodesk.Revit.Exceptions.OperationCanceledException) { return(Result.Cancelled); } return(Result.Succeeded); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public virtual Result Execute(ExternalCommandData commandData , ref string message, ElementSet elements) { // Get the document from external command data. UIDocument activeDoc = commandData.Application.ActiveUIDocument; Autodesk.Revit.DB.Document doc = activeDoc.Document; if (null == doc) { return(Result.Failed); } try { // Start detailed steel modeling transaction using (FabricationTransaction trans = new FabricationTransaction(doc, false, "Create corner cut")) { // for more details, please consult http://www.autodesk.com/adv-steel-api-walkthroughs-2019-enu Reference eRef = activeDoc.Selection.PickObject(ObjectType.Element, "Pick a plate"); FilerObject filerObj = Utilities.Functions.GetFilerObject(doc, eRef); if (null == filerObj) { return(Result.Failed); } if (!(filerObj is Plate)) { return(Result.Failed); } // Point of reference for the corner cut feature. We use GlobalPoint. GlobalPoint is the point where the plate is being hit when selected. Point3d p1 = new Point3d(eRef.GlobalPoint.X, eRef.GlobalPoint.Y, eRef.GlobalPoint.Z); Plate plate = filerObj as Plate; // Adding the corner cut feature to the plate. Coordinates are scaled from [ft] to [mm] int edgeIndex, vertexIndex; plate.GetEdgeAndVertex(p1 * Utilities.Functions.FEET_TO_MM, out edgeIndex, out vertexIndex); double radius = 35.0; PlateFeatVertFillet plateFillet = new PlateFeatVertFillet(0, (short)vertexIndex, radius); plate.AddFeature(plateFillet); trans.Commit(); } } catch (Autodesk.Revit.Exceptions.OperationCanceledException) { return(Result.Cancelled); } return(Result.Succeeded); }
internal PlatePolycut(AdvanceSteel.Nodes.SteelDbObject element, Polyline3d cutPolyline, Autodesk.AdvanceSteel.Geometry.Vector3d normal, Autodesk.AdvanceSteel.Geometry.Vector3d lengthVector, List <Property> plateFeatureProperties) { lock (access_obj) { using (var ctx = new SteelServices.DocContext()) { List <Property> defaultData = plateFeatureProperties.Where(x => x.Level == ".").ToList <Property>(); List <Property> postWriteDBData = plateFeatureProperties.Where(x => x.Level == "Z_PostWriteDB").ToList <Property>(); string existingFeatureHandle = SteelServices.ElementBinder.GetHandleFromTrace(); string elementHandle = element.Handle; FilerObject obj = Utils.GetObject(elementHandle); PlateContourNotch plateFeat = null; if (obj != null && obj.IsKindOf(FilerObject.eObjectType.kPlate)) { if (string.IsNullOrEmpty(existingFeatureHandle) || Utils.GetObject(existingFeatureHandle) == null) { Plate plate = obj as Plate; plateFeat = new PlateContourNotch(plate, 0, cutPolyline, normal, lengthVector); if (defaultData != null) { Utils.SetParameters(plateFeat, defaultData); } plate.AddFeature(plateFeat); if (postWriteDBData != null) { Utils.SetParameters(plateFeat, postWriteDBData); } } else { plateFeat = Utils.GetObject(existingFeatureHandle) as PlateContourNotch; if (plateFeat != null && plateFeat.IsKindOf(FilerObject.eObjectType.kPlateContourNotch)) { Plate plate = obj as Plate; plate.DelFeature(plateFeat); plate.WriteToDb(); plateFeat = new PlateContourNotch(plate, 0, cutPolyline, normal, lengthVector); AtomicElement atomic = obj as AtomicElement; if (defaultData != null) { Utils.SetParameters(plateFeat, defaultData); } atomic.AddFeature(plateFeat); if (postWriteDBData != null) { Utils.SetParameters(plateFeat, postWriteDBData); } } else { throw new System.Exception("Not a Plate Feature"); } } } else { throw new System.Exception("No Input Element found"); } Handle = plateFeat.Handle; SteelServices.ElementBinder.CleanupAndSetElementForTrace(plateFeat); } } }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public virtual Result Execute(ExternalCommandData commandData , ref string message, ElementSet elements) { // Get the document from external command data. UIDocument activeDoc = commandData.Application.ActiveUIDocument; Autodesk.Revit.DB.Document doc = activeDoc.Document; if (null == doc) { return(Result.Failed); } try { // Start detailed steel modeling transaction using (FabricationTransaction trans = new FabricationTransaction(doc, false, "Create contour cut")) { // for more details, please consult http://www.autodesk.com/adv-steel-api-walkthroughs-2019-enu // Selecting the elements to create the contour cut on Reference eRef = activeDoc.Selection.PickObject(ObjectType.Element, "Please pick an element to create the contour cut on"); // getting the selected element Element elem = null; if (eRef != null && eRef.ElementId != ElementId.InvalidElementId) { elem = doc.GetElement(eRef.ElementId); } if (null == elem) { return(Result.Failed); } // ensuring the element has FabricationData SteelElementProperties cell = SteelElementProperties.GetSteelElementProperties(elem); if (null == cell) { List <ElementId> elemsIds = new List <ElementId>(); elemsIds.Add(elem.Id); SteelElementProperties.AddFabricationInformationForRevitElements(doc, elemsIds); } FilerObject filerObj = Utilities.Functions.GetFilerObject(doc, eRef); if (null == filerObj) { return(Result.Failed); } if (!(filerObj is Plate) && !(filerObj is Beam)) { return(Result.Failed); } // The point where the element was hit when selected. Point3d p1 = new Point3d(eRef.GlobalPoint.X, eRef.GlobalPoint.Y, eRef.GlobalPoint.Z); // Contour coordinates, according to the point where the element was hit when selected double x = Utilities.Functions.FEET_TO_MM * p1.x; // x of upper-left corner of the contour; double y = Utilities.Functions.FEET_TO_MM * p1.y; // y of upper-left corner of the contour; double z = Utilities.Functions.FEET_TO_MM * p1.z; // z of upper-left corner of the contour; // Adding the contour cut, using AdvanceSteel classes. Polyline3d plContour; Polyline3d contour = new Polyline3d(); if (filerObj is Plate) { double w = 500; // width of the contour; double h = 500; // height of the contour; contour.Append(new Point3d(x, y, z)); contour.Append(new Point3d(x + w, y, z)); contour.Append(new Point3d(x + w, y + h, z)); contour.Append(new Point3d(x, y + h, z)); if (contour.VertexCount <= 0) { return(Result.Failed); } Plate plate = filerObj as Plate; plate.GetBaseContourPolygon(1, out plContour); plContour.Project(new Autodesk.AdvanceSteel.Geometry.Plane(contour.Vertices[0], contour.PolyNormal), contour.PolyNormal); PlateContourNotch plateContour = new PlateContourNotch(plate, 0, contour, contour.Normal, contour.Normal.GetPerpVector()); plate.AddFeature(plateContour); } else if (filerObj is Beam) { double w = 50; // width of the contour; double h = 50; // height of the contour; contour.Append(new Point3d(x, y, z)); contour.Append(new Point3d(x + w, y, z)); contour.Append(new Point3d(x + w, y, z + h)); contour.Append(new Point3d(x, y, z + h)); if (contour.VertexCount <= 0) { return(Result.Failed); } Beam beam = filerObj as Beam; Point3d ptClosest = beam.GetClosestPointToSystemline(contour.Vertices[0]); double d1 = ptClosest.DistanceTo(beam.GetPointAtStart()); double d2 = ptClosest.DistanceTo(beam.GetPointAtEnd()); Beam.eEnd beamEnd = d1 > d2 ? Beam.eEnd.kEnd : Beam.eEnd.kStart; Vector3d normal = contour.Normal; Vector3d xVec = normal.GetPerpVector(); BeamMultiContourNotch beamContour = new BeamMultiContourNotch(beam, beamEnd, contour, normal, xVec); beam.AddFeature(beamContour); } trans.Commit(); } } catch (Autodesk.Revit.Exceptions.OperationCanceledException) { return(Result.Cancelled); } return(Result.Succeeded); }